﻿--
-- Script was generated by Devart dbForge Studio 2020 for MySQL, Version 9.0.897.0
-- Product home page: http://www.devart.com/dbforge/mysql/studio
-- Script date 30/12/2022 10:34:39
-- Server version: 8.0.30
-- Client version: 4.1
--

-- 
-- Disable foreign keys
-- 
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;

-- 
-- Set SQL mode
-- 
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

-- 
-- Set character set the client will use to send SQL statements to the server
--
SET NAMES 'utf8';

--
-- Set default database
--
USE disparadores1;

--
-- Drop procedure `referencias`
--
DROP PROCEDURE IF EXISTS referencias;

--
-- Drop trigger `aiclientes`
--
DROP TRIGGER IF EXISTS aiclientes;

--
-- Drop trigger `biempresas`
--
DROP TRIGGER IF EXISTS biempresas;

--
-- Drop trigger `buempresas`
--
DROP TRIGGER IF EXISTS buempresas;

--
-- Drop trigger `biclientes1`
--
DROP TRIGGER IF EXISTS biclientes1;

--
-- Drop trigger `biclientes`
--
DROP TRIGGER IF EXISTS biclientes;

--
-- Drop trigger `buclientes1`
--
DROP TRIGGER IF EXISTS buclientes1;

--
-- Drop trigger `buclientes`
--
DROP TRIGGER IF EXISTS buclientes;

--
-- Set default database
--
USE disparadores1;

DELIMITER $$

--
-- Create trigger `buclientes`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER buclientes
BEFORE UPDATE
ON clientes
FOR EACH ROW
BEGIN
  SET NEW.referencia = CONCAT(NEW.nombre, NEW.codigo);
END
$$

--
-- Create trigger `buclientes1`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER buclientes1
BEFORE UPDATE
ON clientes
FOR EACH ROW
FOLLOWS buclientes
BEGIN
  SET NEW.email = CONCAT(NEW.referencia, "@", NEW.empresa, ".com");
END
$$

--
-- Create trigger `biclientes`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER biclientes
BEFORE INSERT
ON clientes
FOR EACH ROW
BEGIN
  DECLARE numero int DEFAULT 0;

  -- esta solucion el problema es que calcula
  -- el ultimo id asignado en esta session
  -- no a la tabla clientes
  -- SET numero = LAST_INSERT_ID()+1; -- leo el proximo codigo 

  -- necesito hacer que la tabla de estadisticas se actualice
  -- sin necesidad de ejecutar el comando ANALIZE TABLE nombreTabla;
  SET @copia = @@information_schema_stats_expiry; -- realizo una copia del valor de la variable del sistema
  SET @@information_schema_stats_expiry = 0; -- obligo a que se actualicen las estadisticas automaticamente

  -- en la variable numero tengo
  -- el proximo id auto_increment a entregar en la tabla clientes
  SELECT
    AUTO_INCREMENT INTO numero
  FROM INFORMATION_SCHEMA.TABLES
  WHERE table_name = 'clientes'
  AND TABLE_SCHEMA = 'disparadores1';

  SET NEW.referencia = CONCAT(NEW.nombre, numero);

  -- dejo la variable del sistema al valor original
  SET @@information_schema_stats_expiry = @copia;

END
$$

--
-- Create trigger `biclientes1`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER biclientes1
BEFORE INSERT
ON clientes
FOR EACH ROW
FOLLOWS biclientes
BEGIN
  SET NEW.email = CONCAT(NEW.referencia, "@", NEW.empresa, ".com");
END
$$

--
-- Create trigger `buempresas`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER buempresas
BEFORE UPDATE
ON empresas
FOR EACH ROW
BEGIN
  SET @@lc_time_names = 'es_es'; -- LOS MESES Y DIAS EN CASTELLANO

  IF (NEW.fechaEntrada <> OLD.fechaEntrada) THEN
    SET
    NEW.diaSemana = DAYNAME(NEW.fechaEntrada),
    NEW.diaMes = DAY(NEW.fechaEntrada),
    NEW.mes = MONTHNAME(NEW.fechaEntrada),
    NEW.mesNumero = MONTH(NEW.fechaEntrada),
    NEW.anno = YEAR(NEW.fechaEntrada);
  END IF;

END
$$

--
-- Create trigger `biempresas`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER biempresas
BEFORE INSERT
ON empresas
FOR EACH ROW
BEGIN
  SET @@lc_time_names = 'es_es'; -- LOS MESES Y DIAS EN CASTELLANO
  SET
  NEW.diaSemana = DAYNAME(NEW.fechaEntrada),
  NEW.diaMes = DAY(NEW.fechaEntrada),
  NEW.mes = MONTHNAME(NEW.fechaEntrada),
  NEW.mesNumero = MONTH(NEW.fechaEntrada),
  NEW.anno = YEAR(NEW.fechaEntrada);
END
$$

--
-- Create trigger `aiclientes`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER aiclientes
AFTER INSERT
ON clientes
FOR EACH ROW
BEGIN
  -- SOLAMENTE ACTUALIZA EL CAMPO FECHAULTIMO
  -- DE LA EMPRESA PARA LA QUE TRABAJA EL CLIENTE
  -- INTRODUCIDO
  UPDATE empresas e
  SET e.fechaUltimo = NOW()
  WHERE e.empresa = NEW.empresa;
END
$$

--
-- Create procedure `referencias`
--
CREATE
DEFINER = 'root'@'localhost'
PROCEDURE referencias ()
BEGIN
  -- actualizo los registros de clientes cuya referencia este mal calculada
  UPDATE clientes c
  SET codigo = codigo
  WHERE referencia <> CONCAT(nombre, codigo);
END
$$

DELIMITER ;

-- 
-- Restore previous SQL mode
-- 
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;

-- 
-- Enable foreign keys
-- 
/*!40014 SET FOREIGN_KEY_CHECKS = @OLD_FOREIGN_KEY_CHECKS */;